# 目录

## 详情跳转

* [前端git规范](./2-前端Git规范)
* [前端css规范](./3-前端CSS规范)
* [prettier配置推荐](./4-prettier配置推荐)
* [前端js规范](./5-前端JS规范)
* [eslint配置推荐](./6-eslint配置推荐)
* [Vue风格指南](./7-Vue风格指南)



## 讨论汇总

### 文档的集中管理

- [x] 整理讨论通过后，上传到gitlab，通过gitlab cli自动生成gitlab page, 部署在公司内网

- [ ] gitlab 开通page和action功能

### codeReview

* 同项目互相codeReview
  * 业务逻辑处理
  * 注释
  * 方法最大行数
  * 方法命名
  * 目录结构
  * ……

* 不同项目
  * 结构

### git工作流

* git 分支
* git 提交格式
* git tag
* git 合并

### 与后端api接口对接

* 工具的引入： postman / apifox / Yapi / swagger
* 前端： 方便渲染的数据格式
* 后端： 接口文档/注释
* 后端： 接口的成功/失败 实例

### css 风格规范

* 通过`prettier`插件管控： 配置文件
* 分号
* 命名
* 注释
* 声明顺序
* 代码缩进
* ……

[百度CSS规范指南](https://github.com/ecomfe/spec/blob/master/css-style-guide.md)

[腾讯CSS规范指南](http://alloyteam.github.io/CodeGuide/#css)

[Google CSS规范指南](http://iischajn.github.io/trans/htmlcss-guide/)

### Js风格规范

* 通过`eslintrc`插件管控： 配置文件
* 变量命名
* 函数命名
* 函数注释
* 代码缩进
* ……

[百度JS规范](https://github.com/ecomfe/spec/blob/master/javascript-style-guide.md)

### Vue风格规范

* 文件名
* 组件名
* Api顺序
* props定义
* 属性顺序和分行
* ……

[Vue官方风格指南](https://cn.vuejs.org/v2/style-guide/index.html)

[有赞风格指南](https://youzan.github.io/vant/#/zh-CN/style-guide)

### 前端通用框架的搭建

* 在技术选型的时候， 需要考虑布局美观， 交互友好，轻量方便维护
* 搭建的内容包括： 
  *  目录结构层次
  *  路由配置（例如列表页和详情页这两个路由是否有嵌套关系，是要定义动态参数还是查询串参数）
  *  状态管理( 各个模块层级关系 )
  * 导航控制( 菜单是否固定在左侧？页面刷新、点击返回和前进按钮时，是否保持高亮和折叠展开的效果 )
  * 动态权限( 菜单、按钮以及页面 )
  * api集中管理
* 整体框架的通讯处理机制控制（请求->数据转换/处理->数据流转->数据展示交互），比如所涉及的api数据管理机制
* 如何在mock和真实数据请求之间切换？
* 模板， 公共Js，工具js,   公共css 是否要一起维护
* 确定滚动区域的范围是整个页面还是仅限于内容区？如果是内容区，标题、表格头部、脚部页码是否固定？
* 点击列表某一行的编辑按钮时弹框还是页面跳转？
* 统一使用三方库（将一些常用的列出来）

### 公共组件库的开发规范

* 以依赖包的形式提供引用， 参考网上的第三方组件
* 形成组件开发的规范， 包括组件的功能， 输入， 输出， 案例
* 组件结合实际业务， 考虑通用性和复杂度
* 例子：
  * 上传组件（本地上传， oss上传， 文件类型， 大小限制， 成功失败处理）
  * 导入导出组件
  * 时间选择
  * 条件搜索